<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AbstractBlockingExchange.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.exchanges.blocking</a> &gt; <span class="el_source">AbstractBlockingExchange.java</span></div><h1>AbstractBlockingExchange.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.exchanges.blocking;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.BlockingQueue;
import java.util.function.Predicate;

import io.gitlab.littlesaints.protean.exchanges.AbstractMessageExchange;

/**
 * Abstract class for implementing {@link BlockingQueue} based exchanges.
 *
 * @param &lt;Q&gt; the implementation of BlockingQueue to use
 * @param &lt;E&gt; the getType of element
 */
abstract class AbstractBlockingExchange&lt;Q extends BlockingQueue&lt;E&gt;, E&gt; extends AbstractMessageExchange&lt;E&gt; {

	private final Reader&lt;E&gt; reader;

	final Q queue;

	//TODO: implement wait strategy??
<span class="fc" id="L44">	AbstractBlockingExchange(Q queue) {</span>
<span class="fc" id="L45">		this.reader = new _Reader(this.queue = queue);</span>
<span class="fc" id="L46">	}</span>

	private class _Reader implements Reader&lt;E&gt; {

		private final BlockingQueue&lt;E&gt; queue;

<span class="fc" id="L52">		_Reader(BlockingQueue&lt;E&gt; queue) {</span>
<span class="fc" id="L53">			this.queue = queue;</span>
<span class="fc" id="L54">		}</span>

		@Override
		public E poll() {
<span class="fc" id="L58">			return queue.poll();</span>
		}

		@Override
		public List&lt;E&gt; poll(int min, int max, int maxAttempts) {
<span class="fc" id="L63">			List&lt;E&gt; batch = null;</span>
			E e;
<span class="pc bpc" id="L65" title="1 of 4 branches missed.">			for (int attempts = 0; continueProcessing.get() &amp;&amp; attempts &lt; maxAttempts; Thread.yield()) {</span>
<span class="fc bfc" id="L66" title="All 2 branches covered.">				if ((e = queue.poll()) == null) {</span>
<span class="fc bfc" id="L67" title="All 4 branches covered.">					if (batch != null &amp;&amp; batch.size() &gt;= min) {</span>
<span class="fc" id="L68">						break;</span>
					}
<span class="fc" id="L70">					attempts++;</span>
				} else {
<span class="fc bfc" id="L72" title="All 2 branches covered.">					if (batch == null) {</span>
<span class="fc" id="L73">						batch = new ArrayList&lt;&gt;(min);</span>
					}
<span class="fc" id="L75">					batch.add(e);</span>
<span class="fc bfc" id="L76" title="All 2 branches covered.">					if (batch.size() == max) {</span>
<span class="fc" id="L77">						break;</span>
					}
<span class="fc" id="L79">					attempts = 0;</span>
				}
			}
<span class="fc bfc" id="L82" title="All 2 branches covered.">			return batch == null ? Collections.emptyList() : batch;</span>
		}

		@Override
		public List&lt;E&gt; poll(int max) {
<span class="fc" id="L87">			List&lt;E&gt; batch = null;</span>
			E e;
<span class="pc bpc" id="L89" title="1 of 2 branches missed.">			for (; continueProcessing.get(); Thread.yield()) {</span>
<span class="fc bfc" id="L90" title="All 2 branches covered.">				if ((e = queue.poll()) == null) {</span>
<span class="fc" id="L91">					break;</span>
				} else {
<span class="fc bfc" id="L93" title="All 2 branches covered.">					if (batch == null) {</span>
<span class="fc" id="L94">						batch = new ArrayList&lt;&gt;();</span>
					}
<span class="fc" id="L96">					batch.add(e);</span>
<span class="fc bfc" id="L97" title="All 2 branches covered.">					if (batch.size() == max) {</span>
<span class="fc" id="L98">						break;</span>
					}
				}
			}
<span class="fc bfc" id="L102" title="All 2 branches covered.">			return batch == null ? Collections.emptyList() : batch;</span>
		}

		@Override
		public boolean poll(int maxAttempts, Predicate&lt;? super E&gt; consumer) {
<span class="fc" id="L107">			int attempts = 0;</span>
			E e;
<span class="pc bpc" id="L109" title="1 of 4 branches missed.">			for (; continueProcessing.get() &amp;&amp; attempts &lt; maxAttempts; Thread.yield()) {</span>
<span class="fc bfc" id="L110" title="All 2 branches covered.">				if ((e = queue.poll()) == null) {</span>
<span class="fc" id="L111">					attempts++;</span>
				} else {
<span class="fc bfc" id="L113" title="All 2 branches covered.">					if (!consumer.test(e)) {</span>
<span class="fc" id="L114">						break;</span>
					}
<span class="fc" id="L116">					attempts = 0;</span>
				}
			}
<span class="pc bpc" id="L119" title="1 of 4 branches missed.">			return continueProcessing.get() &amp;&amp; attempts == maxAttempts;</span>
		}

		@Override
		public E take() {
			while (true) {
				try {
					//TODO: test shutdown. check if executor terminates
<span class="fc" id="L127">					return queue.take();</span>
<span class="nc" id="L128">				} catch (InterruptedException x) {</span>
//					x.printStackTrace();
<span class="nc" id="L130">				}</span>
			}
		}

		@Override
		public List&lt;E&gt; take(int min, int max) {
<span class="nc" id="L136">			List&lt;E&gt; batch = null;</span>
			E e;
<span class="nc bnc" id="L138" title="All 2 branches missed.">			for (; continueProcessing.get(); Thread.yield()) {</span>
<span class="nc bnc" id="L139" title="All 2 branches missed.">				if ((e = queue.poll()) == null) {</span>
<span class="nc bnc" id="L140" title="All 4 branches missed.">					if (batch != null &amp;&amp; batch.size() &gt;= min) {</span>
<span class="nc" id="L141">						break;</span>
					}
				} else {
<span class="nc bnc" id="L144" title="All 2 branches missed.">					if (batch == null) {</span>
<span class="nc" id="L145">						batch = new ArrayList&lt;&gt;(min);</span>
					}
<span class="nc" id="L147">					batch.add(e);</span>
<span class="nc bnc" id="L148" title="All 2 branches missed.">					if (batch.size() == max) {</span>
<span class="nc" id="L149">						break;</span>
					}
				}
			}
<span class="nc bnc" id="L153" title="All 2 branches missed.">			return batch == null ? Collections.emptyList() : batch;</span>
		}

		@Override
		public List&lt;E&gt; take(int min) {
<span class="nc" id="L158">			List&lt;E&gt; batch = null;</span>
			E e;
<span class="nc bnc" id="L160" title="All 2 branches missed.">			for (; continueProcessing.get(); Thread.yield()) {</span>
<span class="nc bnc" id="L161" title="All 2 branches missed.">				if ((e = queue.poll()) == null) {</span>
<span class="nc bnc" id="L162" title="All 4 branches missed.">					if (batch != null &amp;&amp; batch.size() &gt;= min) {</span>
<span class="nc" id="L163">						break;</span>
					}
				} else {
<span class="nc bnc" id="L166" title="All 2 branches missed.">					if (batch == null) {</span>
<span class="nc" id="L167">						batch = new ArrayList&lt;&gt;(min);</span>
					}
<span class="nc" id="L169">					batch.add(e);</span>
				}
			}
<span class="nc bnc" id="L172" title="All 2 branches missed.">			return batch == null ? Collections.emptyList() : batch;</span>
		}

		@Override
		public void take(Predicate&lt;? super E&gt; consumer) {
<span class="pc bpc" id="L177" title="1 of 4 branches missed.">			for (E e; (e = take()) != null &amp;&amp; consumer.test(e); ) ;</span>
<span class="fc" id="L178">		}</span>

	}

	@Override
	public Reader&lt;E&gt; getReader() {
<span class="fc" id="L184">		return reader;</span>
	}


	@Override
	public boolean isEmpty() {
<span class="nc" id="L190">		return queue.isEmpty();</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>